Closure::__construct
Closure::bindTo
Closure
PHP Manual

# Closure::bind

(PHP 5 >= 5.4.0)

Closure::bind — Duplicates a closure with a specific bound object and class scope

### Description

public static Closure Closure::bind ( Closure `$closure` , object `$newthis` [, mixed `$newscope` = "static" ] )

This method is a static version of Closure::bindTo(). See the documentation of that method for more information.

### Parameters

`closure`

  The anonymous functions to bind.

`newthis`

  The object to which the given anonymous function should be bound, or `NULL` for the closure to be unbound.

`newscope`

  The class scope to which associate the closure is to be associated, or 'static' to keep the current one. If an object is given, the type of the object will be used instead. This determines the visibility of protected and private methods of the bound object. It is not allowed to pass (an object of) an internal class as this parameter.

### Return Values

Returns a new Closure object or `FALSE` on failure

### Changelog

Version | Description
--- | ---
7.0.0 | `newscope` can not be (an object of) an internal class anymore, what was possible prior to this version.

### Examples

Example #1 Closure::bind() example

`<?php
class A {
private static $sfoo = 1;
private $ifoo = 2;
}
$cl1 = static function() {
return A::$sfoo;
};
$cl2 = function() {
return $this->ifoo;
};
$bcl1 = Closure::bind($cl1, null, 'A');
$bcl2 = Closure::bind($cl2, new A(), 'A');
echo $bcl1(), "\n";
echo $bcl2(), "\n";
?>`

The above example will output something similar to:

    1
    2

### See Also

- Anonymous functions
- Closure::bindTo() - Duplicates the closure with a new bound object and class scope

Closure::__construct
Closure::bindTo
Closure
PHP Manual